Loading...
Searching...
No Matches
gs_bm.c File Reference

OGSF library - manipulating bitmaps (lower level functions). More...

`#include <grass/gis.h>`
`#include <grass/glocale.h>`
`#include <grass/ogsf.h>`
`#include "gsget.h"`
Include dependency graph for gs_bm.c:

Go to the source code of this file.

## Macros

#define | MASK_OR 1
| mask types
#define | MASK_ORNOT 2
#define | MASK_AND 3
#define | MASK_XOR 4

## Functions

struct BM * | gsbm_make_mask (typbuff *frombuff, float maskval, int rows, int cols)
| Do combining of bitmaps, make bitmaps from other data w/maskval.
void | gsbm_zero_mask (struct BM *map)
| Zero mask.
int | gsbm_or_masks (struct BM *bmvar, struct BM *bmcon)
| Mask bitmap (mask type OR).
int | gsbm_ornot_masks (struct BM *bmvar, struct BM *bmcon)
| Mask bitmap (mask type ORNOT).
int | gsbm_and_masks (struct BM *bmvar, struct BM *bmcon)
| Mask bitmap (mask type ADD).
int | gsbm_xor_masks (struct BM *bmvar, struct BM *bmcon)
| Mask bitmap (mask type XOR).
int | gs_update_curmask (geosurf *surf)
| Update current maps.
void | print_bm (struct BM *bm)
| Print bitmap to stderr.

## Detailed Description

OGSF library - manipulating bitmaps (lower level functions).

GRASS OpenGL gsurf OGSF Library

(C) 1999-2008 by the GRASS Development Team

This program is free software under the GNU General Public License (>=v2). Read the file COPYING that comes with GRASS for details.

Author
  Bill Brown USACERL, GMSL/University of Illinois (September 1993)
  Doxygenized by Martin Landa <landa.martin gmail.com> (May 2008)

Definition in file gs_bm.c.

## Macro Definition Documentation

## MASK_AND

#define MASK_AND 3

Definition at line 97 of file gs_bm.c.

Referenced by gsbm_and_masks().

## MASK_OR

#define MASK_OR 1

mask types

Definition at line 95 of file gs_bm.c.

Referenced by gsbm_or_masks().

## MASK_ORNOT

#define MASK_ORNOT 2

Definition at line 96 of file gs_bm.c.

Referenced by gsbm_ornot_masks().

## MASK_XOR

#define MASK_XOR 4

Definition at line 98 of file gs_bm.c.

Referenced by gsbm_xor_masks().

## Function Documentation

## gs_update_curmask()

int gs_update_curmask | ( | geosurf * | surf | ) |

Update current maps.

Parameters

  surf | surface (geosurf)

Returns
  0
  1

Definition at line 228 of file gs_bm.c.

References BM_create(), BM_destroy(), BM_set(), G_debug(), gs_get_att_typbuff(), gs_mapcolor(), gs_mask_defined(), gs_masked(), gs_set_maskmode(), gsbm_make_mask(), gsbm_or_masks(), gsbm_ornot_masks(), gsbm_zero_mask(), and NULL.

Referenced by gpd_2dsite(), gs_calc_normals(), GS_load_att_map(), GS_update_curmask(), gsd_coarse_surf_map(), gsd_norm_arrows(), gsd_surf_const(), gsd_surf_map(), gsd_surf_map_old(), gsd_wire_arrows(), gsd_wire_surf_const(), gsd_wire_surf_map(), and gvd_vect().

## gsbm_and_masks()

int gsbm_and_masks | ( | struct BM * | bmvar,
|  | struct BM * | bmcon )

Mask bitmap (mask type ADD).

Must be same size, ADDs bitmaps & stores in bmvar

Parameters

  bmvar | bitmap (BM) to changed
  bmcon | bitmap (BM)

Returns
  -1 on failure (bitmap mispatch)
  0 on success

Definition at line 199 of file gs_bm.c.

References MASK_AND.

## gsbm_make_mask()

struct BM * gsbm_make_mask | ( | typbuff * | frombuff,
|  | float | maskval,
|  | int | rows,
|  | int | cols )

Do combining of bitmaps, make bitmaps from other data w/maskval.

Parameters

  frombuff | data buffer
  maskval | mask type
  rows | number of rows
  cols | number of cols

Returns
  pointer to BM struct

Definition at line 35 of file gs_bm.c.

References BM_create(), BM_get(), BM_set(), and GET_MAPATT.

Referenced by gs_update_curmask().

## gsbm_or_masks()

int gsbm_or_masks | ( | struct BM * | bmvar,
|  | struct BM * | bmcon )

Mask bitmap (mask type OR).

Must be same size, ORs bitmaps & stores in bmvar

Parameters

  bmvar | bitmap (BM) to changed
  bmcon | bitmap (BM)
  mask_type | mask type (see mask types macros)

Returns
  -1 on failure (bitmap mispatch)
  0 on success

Definition at line 167 of file gs_bm.c.

References MASK_OR.

Referenced by gs_update_curmask().

## gsbm_ornot_masks()

int gsbm_ornot_masks | ( | struct BM * | bmvar,
|  | struct BM * | bmcon )

Mask bitmap (mask type ORNOT).

Must be same size, ORNOTs bitmaps & stores in bmvar

Parameters

  bmvar | bitmap (BM) to changed
  bmcon | bitmap (BM)

Returns
  -1 on failure (bitmap mispatch)
  0 on success

Definition at line 183 of file gs_bm.c.

References MASK_ORNOT.

Referenced by gs_update_curmask().

## gsbm_xor_masks()

int gsbm_xor_masks | ( | struct BM * | bmvar,
|  | struct BM * | bmcon )

Mask bitmap (mask type XOR).

Must be same size, XORs bitmaps & stores in bmvar

Parameters

  bmvar | bitmap (BM) to changed
  bmcon | bitmap (BM)

Returns
  -1 on failure (bitmap mispatch)
  0 on success

Definition at line 215 of file gs_bm.c.

References MASK_XOR.

## gsbm_zero_mask()

void gsbm_zero_mask | ( | struct BM * | map | ) |

Zero mask.

Parameters

  map | pointer to BM struct

Definition at line 77 of file gs_bm.c.

Referenced by gs_update_curmask().

## print_bm()

void print_bm | ( | struct BM * | bm | ) |

Print bitmap to stderr.

Parameters

  bm | bitmap (BM)

Definition at line 358 of file gs_bm.c.

References BM_get().